/*
	*	Author OverGame development.
	*	Version R3.Final (Reborn III Final version)
	
	*	The material can be found on the website https://forums.alliedmods.net/
	*	Especially for https://forums.alliedmods.net/
	
	*	My contacts (i do custom plugins):
	
										[SKYPE]:	vzlomgame
										[STEAM]:	https://steamcommunity.com/id/qwertyhard
										[VK]:		https://vk.com/qwertyhard
										[WEB]:		http://cs-ke.ru
*/


#include amxmodx
#include fakemeta
#include hamsandwich

new bool:g_iKnife[33];

public plugin_precache () {
	engfunc(EngFunc_PrecacheModel, "models/v_aknife.mdl");					//View model
	engfunc(EngFunc_PrecacheModel, "models/p_aknife.mdl");					//Model by
}

public plugin_init () {
	register_plugin ("Admin Knife", "R3.Final", "OverGame");
	register_dictionary ("admin_knife.txt");
	
	register_cvar ("aknife_damage",		"0.33");							//x*N Damage
	register_cvar ("aknife_bunnyhop",	"1");								//Bunny Hopping
	register_cvar ("aknife_flags",		"t");								//Flag access knife
	
	register_clcmd ("aknife",			"ClCmd_SayAKnife");
	register_clcmd ("say /aknife",		"ClCmd_SayAKnife");
	register_clcmd ("say_team /aknife", "ClCmd_SayAKnife");
	
	RegisterHam (Ham_TakeDamage,	"player",			"Ham_PlayerDamage_Pre",			false);
	RegisterHam (Ham_Player_Jump,	"player",			"Ham_PlayerJump_Pre",			false);
	RegisterHam (Ham_Item_Deploy,	"weapon_knife",		"Ham_DeployKnife_Post",			true);
}

public client_putinserver (id) g_iKnife[id] = false;

public ClCmd_SayAKnife (id) {
	new szFlags[10];
	get_cvar_string ("aknife_flags", szFlags, 9);
	
	if (~get_user_flags(id) & read_flags(szFlags)) {
		client_print (id, print_chat, "%L", id, "AKN_ACCESS");
		return PLUGIN_HANDLED;
	}
	
	client_print (id, print_chat, "%L", id, "AKN_SELECT", id, (g_iKnife[id] = g_iKnife[id] ? false : true) ? "AKN_ADMIN" : "AKN_STAND");
	
	if (is_user_alive(id) && get_user_weapon(id) == CSW_KNIFE) {
		set_pev (id, pev_viewmodel2,			g_iKnife[id] ? "models/v_aknife.mdl" : "models/v_knife.mdl");
		set_pev (id, pev_weaponmodel2,			g_iKnife[id] ? "models/p_aknife.mdl" : "models/p_knife.mdl");
	}
	
	return PLUGIN_HANDLED;
}

public Ham_PlayerDamage_Pre (iVictim, iInf, iAttacker, Float:fDamage) {
	if (!is_user_connected(iAttacker) || get_user_weapon(iAttacker) != CSW_KNIFE ||
			iVictim == iAttacker || !iVictim || !g_iKnife[iAttacker]) return;
	
	new Float:fSendDamage = get_cvar_float ("aknife_damage");
	if (floatround (fSendDamage) == 0) return;
	
	SetHamParamFloat(4, fDamage * fSendDamage);
}

public Ham_PlayerJump_Pre (id) {
	if (!is_user_alive(id) || !g_iKnife[id] || !get_cvar_num("aknife_bunnyhop")) return;
	
	static iOldButtons ; iOldButtons = pev (id, pev_oldbuttons);
	if (iOldButtons & IN_JUMP && pev (id, pev_flags) & FL_ONGROUND) {
		iOldButtons &= ~IN_JUMP;
		set_pev (id, pev_oldbuttons, iOldButtons);
		set_pev (id, pev_gaitsequence, 6);
		set_pev (id, pev_frame, 0.0);
		
		return;
	}
	
	return;
}

public Ham_DeployKnife_Post (iWeapon) {
	new id = get_pdata_cbase (iWeapon, 41, 4);
	
	if (is_user_alive(id) && g_iKnife[id]) {
		set_pev (id, pev_viewmodel2,			"models/v_aknife.mdl");
		set_pev (id, pev_weaponmodel2,			"models/p_aknife.mdl");
	}
	
	return HAM_IGNORED;
}